import os, re

from paths import *

from node import Node, File, Directory, extension
#from log import Log
from image import Image
from sound import Sound

#see below for Directory and MediaList imports
#since they import make_node, make_node needs to be defined first

def make_node(path='', node_type=None, relative=True, create=True, local_path=local_path):
    """
    take either a relative or absolute path
    looks at the path,
    determines the right kind of node to associate with that path
    returns the node

    [2008.11.18 19:47:46]
    might be a way to do this with meta classes

    looks like this is a bit of a class factory

    suggestions welcome!
    """
    if relative:
        actual_path = os.path.join(unicode(local_path), path)
        #actual_path = unicode(os.path.join(local_path, path))
    else:
        actual_path = path

    actual_path = unicode(actual_path)
    actual_path = os.path.normpath(actual_path)

    new_node = None
    if (create and not os.path.exists(actual_path) and
        extension(actual_path) == "txt"):
        #only want to create new log files, and then only if logging
        #is enabled
        #should be equivalent to a touch
        f = file(actual_path, 'w')
        f.close()

    #to skip throwing an error if no file exists, uncomment following:
    #if os.path.exists(actual_path):
    if not node_type:
        new_node = Node(actual_path)
        node_type = new_node.find_type()
        if node_type in [ "Playlist", "Movie", "Document", "Library", "Log" ]:
            #special case
            node_type = "File"
            
    #ah ha!  passing in path as unicode is very important if planning to work
    #with unicode paths... otherwise gets converted to ascii here:
    #new_node = eval("%s(u'%s')" % (node_type, actual_path))
    #above is causing trouble on windows, trying without

    #node_create = "%s(r'%s')" % (node_type, actual_path)
    #node_create = r'%s("%s")' % (node_type, actual_path)
    #re.subn(r"\\", r"\\\\", node_create)
    #new_node = eval(node_create)

    #2008.12.23 14:18:59
    #eval having a hard time with windows.  switching to a nested if-else:
    if node_type == "Node":
        #new_node already defined:
        pass
    elif node_type == "Directory":
        new_node = Directory(actual_path)
    elif node_type == "Image":
        new_node = Image(actual_path)
    elif node_type == "Sound":
        new_node = Sound(actual_path)
    else:# node_type == "File":
        new_node = File(actual_path)

    return new_node


#from directory import MediaList 
