import logging

from pylons import request, response, session, tmpl_context as c
from pylons.controllers.util import abort, redirect_to

from pose.lib.base import BaseController, render
from pose import model

log = logging.getLogger(__name__)

import os, subprocess, re

from pylons import config
admin = config['admin']
if admin == "False":
    admin = False
else:
    admin = True
    
local_path = u'./'
if config.has_key('local_path'):
    local_path = unicode(config['local_path'])

from routes import url_for

from medialist.medialist import MediaList
from moments.timestamp import Timestamp

class DirectoryController(BaseController):

    def index(self):
        c.timestamp = Timestamp(now=True)
        d = model.make_node()
        c.node = d
        c.admin = admin
        d.scan_filetypes()
        #d.images.sort()
        #d.sub_directories.sort()
        #c.sub_dir_list = d.sub_directories.as_objects()
        c.sub_dir_list = d.sub_directories
        return render('/root.mako')

    def directory(self, dname):
        c.admin = admin
        
        ##old way... pre make_node():
        #local_path = os.path.join(image_dir, dname)
        #d = model.Directory(local_path)
        #d = model.Directory(dname)
        d = model.make_node(dname)
        d.scan_filetypes()
        c.node = d
        c.d = d

        #d.playlists.sort()
        playlists = MediaList(d.playlists, item_type='File')
        playlists.sort_items()
        d.playlists = playlists.as_objects()

        #d.logs.sort()
        logs = MediaList(d.logs, item_type='File')
        logs.sort_items()
        d.logs = logs.as_objects()

        movies = MediaList(c.movies, item_type='Movie')
        movies.sort_items()
        d.movies = movies.as_objects()
        #d.movies.sort()
        #c.movies = d.movies
        
        sounds = MediaList(d.sounds, item_type='Sound')
        sounds.sort_items()
        d.sounds = sounds.as_objects()
        c.sounds = d.sounds

        #d.images.sort()
        #c.images = d.get_images()
        images = MediaList(d.images, item_type='Image')
        images.sort_items()
        c.images = images.as_objects()

        #d.sub_directories.sort()
        #c.sub_dir_list = d.sub_directories.as_objects()
        #c.sub_dir_list = d.sub_directories
        #c.sub_dir_list = []
        dirs = MediaList(d.sub_directories, item_type='Directory')
        dirs.sort_items()
        c.sub_dir_list = dirs.as_objects()


        return render('/directory/directory.mako')

    def as_links(self, dname):
        c.admin = admin
        
        d = model.make_node(dname)
        d.scan_filetypes()

        dirs = MediaList(d.sub_directories, item_type='Directory')
        dirs.sort_items()

        return dirs.to_links()

    def slideshow(self, dname):
        #local_path = os.path.join(image_dir, dname)
        #d = model.Directory(local_path)
        #d = model.Directory(dname)
        d = model.make_node(dname)
        d.scan_filetypes()
        c.node = d
        #c.ilist = d.get_images()
        c.ilist = d.images
        #c.sounds = d.sounds
        #c.movies = d.movies
        #c.admin = admin
        #c.d = d
        return render('/slide.mako')

    def auto_rotate(self, dname):
        #d = model.Directory(dname)
        d = model.make_node(dname)

        c.admin = admin

        result = d.auto_rotate_images()
        if not result:
            result = "Nothing needed rotation"
        session['flash'] = 'Auto Rotate Result: %s Reload page to see updates' % result
        session.save()
        
        return redirect_to(url_for(action='directory', dname=dname))

    def create(self):
        if request.params.has_key('dname'):
            dname = request.params['dname']
        else:
            dname = ''
        if admin:
            new_item = request.params['local_name']
            if new_item:
                full_path = os.path.join(unicode(local_path), dname, new_item)
                if not os.path.exists(full_path):
                    what = request.params['type']
                    if what == "directory":
                        os.mkdir(full_path)
                        session['flash'] = 'New directory created: %s' % full_path
                        session.save()

                    elif what == "html":
                        if not re.search(".htm(l*)", full_path):
                            full_path = full_path + ".html"
                        f = file(full_path, 'w')
                        f.close()
                        session['flash'] = 'New html file created: %s' % full_path
                        session.save()

                    elif what == "log":
                        if not re.search(".txt", full_path):
                            full_path = full_path + ".txt"
                        f = file(full_path, 'w')
                        f.close()
                        session['flash'] = 'New journal file created: %s' % full_path
                        session.save()
                        
                else:
                    session['flash'] = 'Item already exists!: %s' % full_path
                    session.save()
            else:
                session['flash'] = 'No file name specified!'
                session.save()
                

            #print "creating directory"
        return redirect_to(url_for(action='directory', dname=dname))
    
    def update_many(self):
        if request.params.has_key('dname'):
            dname = request.params['dname']
        else:
            dname = ''

        result = ''

        c.admin = admin
        if admin:
            action = request.params['action']
            data = request.params['data']
            file_list = []
            for param in request.params.keys():
                if param not in ['action', 'data', 'submit', 'dname', 'items']:
                    rel_path = os.path.join(dname, param)
                    
                    if request.params['items'] == 'images':
                        item = model.make_node(rel_path, "Image")
                        #item = model.Image(rel_path)
                    elif request.params['items'] == 'directories':
                        item = model.make_node(rel_path, "Directory")
                        #item = model.Directory(rel_path)
                    else:
                        item = model.make_node(rel_path)
                        #item = model.Node(rel_path)
                        
                    if action == 'rotate':
                        item.rotate(int(data))
                        #result += "Rotated: %s by: %s degrees\n" % (item, data)
                    elif action == 'move':
                        #should probably do some error checking on data
                        #make sure it's a valid name
                        destination = os.path.join(data, param)
                        item.move(destination)
                        #result += "Moved: %s to: %s\n" % (item, destination)
                    elif action == 'tag':
                        file_list.append(param)

                    result += "%s, " % item.name

                        
            #after loop, then we can add tags:
            if action == 'tag':
                d = model.make_node(dname)
                #d = model.Directory(dname)
                tag_list = data.split()
                if len(file_list) == 0:
                    raise("AttributeError", "no data to tag")
                elif len(file_list) == 1:
                    data = file_list[0]
                else:
                    data = '['
                    for f in file_list:
                        data += f + ' '
                    data += ']'
                d.add_tags(tag_list, data)

            if result:
                if action == 'move':
                    result = "Moved %s to %s" % (result, data)
                elif action == 'rotate':
                    result = "Rotated %s by %s degrees" % (result, data)
                session['flash'] = result
                session.save()
            
        #c.image = i
        if dname:
            return redirect_to(url_for(controller='directory', action='directory', dname=dname))
        else:
            return redirect_to(url_for(controller='directory', action='index'))


