import logging

from pylons import request, response, session
from pylons import tmpl_context as c
from pylons.controllers.util import abort, redirect_to

from pose.lib.base import BaseController, render
import pose.model as model

log = logging.getLogger(__name__)

#see MediaController for admin and log_action definitions
from media import *

from medialist.medialist import MediaList

class ImageController(MediaController):

    def view(self, dname, iname):
        #d = model.Directory(dname)
        d = model.make_node(dname)
        #initialize the image list
        d.scan_filetypes()
        #d.get_images()
        images = MediaList(d.images, item_type='Images')
        images.sort_items()
        
        #c.image = model.Image(os.path.join(dname, iname))
        c.image = model.make_node(os.path.join(dname, iname), "Image")
        #c.prev = d.images.get_object(d.images.get_prev(c.image.path))
        c.prev = images.get_object(images.get_prev(c.image.path))

        #from momentlog.entry import Entry
        #from datetime import datetime
        #log = model.make_node(os.path.join(dname, "action.txt"))
        #entry = Entry(c.image.path, ['view'], datetime.now())
        #log.log.from_entries([entry])
        #log.log.to_file()
        c.image.log_action(["view", "large", "image"])
        
        #c.next = d.images.get_object(d.images.get_next(c.image.path))
        c.next = images.get_object(images.get_next(c.image.path))

        lookahead = 4
        #cur_pos = d.images.jump_to_item(i.path)
        cur_pos = images.cur_pos
        
        nexts = []
        for i in range(cur_pos+1, cur_pos+lookahead+1):
            ipath = images.jump_to_num(i)
            if ipath:
                nexts.append(images.get_object(ipath))

        if len(nexts) < lookahead:
            nexts.append(images.get_object(images.jump_to_num(0)))
        c.nexts = nexts

        c.admin = admin
        c.dir = d
        if not config.has_key('enable_full') or config['enable_full'] == 'True':
            c.link_full = True
        else:
            c.link_full = False
        return render('/image/image-horizontal.mako')

    def update(self):
        #in image.mako, add following to use this method:
        #<%include file="/image/image.form" />
        
        dname = request.params['dname']
        iname = request.params['iname']
        if admin:
            deg = request.params['degrees']
            #i = model.Image(os.path.join(dname, iname))
            i = model.make_node(os.path.join(dname, iname), "Image")
            i.rotate(int(deg))

        c.admin = admin
        return redirect_to(str(i.relative_path()))

