import logging

from pylons import request, response, session, tmpl_context as c
from pylons.controllers.util import abort, redirect_to

from pose.lib.base import BaseController, render
from pose import model

log = logging.getLogger(__name__)

import os, subprocess

from pylons import config
admin = config['admin']
if admin == "False":
    admin = False
else:
    admin = True
    
from osbrowser.node import local_to_relative

class MediaController(BaseController):

    def index(self, dname, fname):
        """
        hook to log a view/listen on a local file

        this is the file itself

        should be callable with a:
        node.custom_relative_path(prefix="media")
        """
        node = model.make_node(os.path.join(dname, fname))
        node.log_action(["access", "original", "media", "file"])
        #print node.make_relative_path()
        
        return redirect_to(str(local_to_relative(node.path, add_prefix=True)))
        #return redirect_to(str(node.make_relative_path(add_prefix=True)))
        #return redirect_to(str(node.custom_relative_path()))

    def tag(self):
        dname = request.params['dname']
        iname = request.params['iname']
        if admin:
            tag_string = request.params['tags']
            #d = model.Directory(dname)
            d = model.make_node(dname)
            d.add_tags(tag_string)

        c.admin = admin
        return redirect_to(str(i.relative_path()))

    def mplayer(self, dname, mname):
        f = model.make_node(os.path.join(dname, mname))
        f.log_action(["watch", "movie"])
        cmd = 'mplayer -softvol -vo xv "%s"' % f.path
        pipe = subprocess.Popen(cmd, shell=True)
        return redirect_to(str(os.path.join('/', dname)))

    
