import logging

from pylons import request, response, session, tmpl_context as c
from pylons.controllers.util import abort, redirect_to

from pose.lib.base import BaseController, render
from pose import model

log = logging.getLogger(__name__)

from media import *

from osbrowser.node import local_to_relative

class SoundController(MediaController):

    def play(self, dname, fname):
        """
        hook to log a view/listen on a local file

        this is the file itself

        should be callable with a:
        node.custom_relative_path(prefix="media")
        """
        node = model.make_node(os.path.join(dname, fname))
        node.log_action(["play", "sound"])
        return redirect_to(str(local_to_relative(node.path, add_prefix=True)))
