import os
from datetime import datetime
import logging

from pylons import request, response, session, tmpl_context as c
from pylons.controllers.util import abort, redirect_to

from pose.lib.base import BaseController, render
from pose import model

log = logging.getLogger(__name__)

#from moments.association import tags_from_string
from moments.tags import Tags # tags_from_string
from moments.journal import Journal

from pylons import config
local_buffer = os.path.join(config['local_path'])

os.path.join(config['local_path'])

from webhelpers.html import literal

class TagController(BaseController):

    def index(self, tag_string, fpath):
        """
        build a journal rooted at fpath
        then filter entries based on tags

        defaulting to union
        """
        return self.union(tag_string, fpath)

    def union(self, tag_string, fpath):
        c.fpath = fpath
        node = model.make_node(fpath)
        c.node = node
        j = node.create_journal()
        tags = Tags().from_tag_string(tag_string)
        #tags = tags_from_string(tag_string)
        c.entries = j.union_tags(tags)
        return render('/journal/log.mako')        

    def intersect(self, tag_string, fpath):
        c.fpath = fpath
        node = model.make_node(fpath)
        c.node = node
        j = node.create_journal()
        tags = Tags().from_tag_string(tag_string)
        #tags = tags_from_string(tag_string)
        c.entries = j.intersect_tags(tags)
        return render('/journal/log.mako')        

    def cloud(self, fpath):
        node = model.make_node(fpath)
        j = node.create_journal()
        c.title = "Tag Cloud: %s" % fpath
        #print "path: %s, name: %s, name_only: %s" % (node.path, node.name, node.name_only)
        c.body = literal(j.tags.make_cloud(url_template='/tag/%s/'+fpath, ignores = node.context_tags()))
        #c.body = literal(j.tags.make_cloud(url_prefix='/journal/tags/', ignores = ['administrator', 'administration', 'todo', 'svn']))
        return render('/content.mako')
        #return str(j.tags.make_cloud())

    def _extract_one(self, tags, node, extract_type):

        these_tags = []
        filename_tags = node.context_tags()
        these_tags.extend(filename_tags)
        j = Journal()
        j.from_file(node.path, add_tags=these_tags)
        entries = j.extract(tags, extract_type)
        #when it's time to save:
        #j.to_file()
        return entries
    
    def extract(self, tag_string, fpath, extract_type='intersect'):
        """
        for merging, see admin controller
        could be tricky with only one file to specify
        might need to use command line for this for now
        
        for each file in fpath
        add any entry that matches tag_string criteria
        to a local buffer
        [local buffer will need to be a static (pre-configured) path
         since we only have one variable path to work with,
         and that needs to be the source
         we can generate the output filename based on date and tags extracted
         ]

        and save original/source journal/log file without the extracted entries

        very similar to Node->create_journal()
        but different enough that I think it should be separate
        (at least until it works... then can cosider refactoring)
        """
        c.fpath = fpath
        node = model.make_node(fpath)

        extracts = Journal()

        tags = Tags().from_tag_string(tag_string)
        #tags = tags_from_string(tag_string)
        add_tags = []
        ignore_dirs = [ 'downloads', 'binaries' ]
        if node.find_type() == "Directory":
            for root,dirs,files in os.walk(node.path):
                for f in files:
                    if not re.compile('.*\.txt$').search(f):
                        continue

                    if not check_ignore(os.path.join(root, f), ignore_dirs):
                        fnode = make_node(os.path.join(root, f))
                        entries = self._extract_one(tags, fnode, extract_type)
                        print "%s entries found in %s" % (len(entries), fnode.path)
                        extracts.from_entries(entries)
                        
        elif node.find_type() == "Log":
            entries = self._extract_one(tags, node, extract_type)
            print "%s entries found in %s" % (len(entries), node.path)
            extracts.from_entries(entries)
        else:
            #no journal to create
            pass

        #save the extracts journal to a log
        #now that we've extracted everything
        t = datetime.now()
        now = t.strftime("%Y%m%d%H%M%S")
        fname = now + '-' + tag_string + '.txt'
        dest = os.path.join(config['log_local_path'], fname)
        print "saving %s entries to %s" % (len(extracts.to_entries()), dest)
        extracts.to_file(dest)

        #could gather print statements to have something to return here:
        #return output
