<%inherit file="/site.mako" />
<%def name="title()">${c.d.name}</%def>

<%include file="/breadcrumbs.mako" args="node=c.d"/>

% if c.d.images:
<%include file="/image/image_list.mako" />
% endif


<div class="row">
% if c.d.playlists:
<br>
<h3>Playlists:</h3>
% for p in c.d.playlists:
${h.link_to("[edit]", p.custom_relative_path(prefix="/playlist/edit"))}
${h.link_to("[in browser]", p.custom_relative_path(prefix="/playlist"))}
${h.link_to(p.name, p.custom_relative_path(prefix="/playlist/file"))}<br>
% endfor
% endif
</div>

% if c.d.logs:
<div class="row">
<h3>Moment Logs:</h3> ${h.link_to("[merge all]", c.d.custom_relative_path(prefix="/journal"))} ${h.link_to("[cloud]", c.d.custom_relative_path(prefix="/tag/cloud"))}<br>
<br>
% for p in c.d.logs:
${h.link_to("[edit]", p.custom_relative_path(prefix="/journal/edit"))}
${h.link_to("[images]", p.custom_relative_path(prefix="/journal/images"))}
${h.link_to("[sounds]", p.custom_relative_path(prefix="/journal/sounds"))}
${h.link_to("[local links]", p.custom_relative_path(prefix="/journal/local_links"))}
${h.link_to(p.name, p.custom_relative_path(prefix="/journal/log"))}<br>
% endfor
</div>
% endif

% if c.d.movies:
<%include file="/generic_list.mako" args="title='Movies', prefix='/file/mplayer', items=c.d.movies"/>
% endif

% if c.d.sounds:
<h3>Sounds:</h3>
<%include file="/sound_list.mako" />
% endif

% if c.d.documents:
<h3>Documents:</h3>
% for o in c.d.documents:
${h.link_to("[edit]", o.custom_relative_path(prefix="/html/edit"))}
${h.link_to(o.name, o.custom_relative_path(prefix="/html"))}<br>
% endfor
% endif

% if c.d.libraries:
<%include file="/generic_list.mako" args="title='Libraries', prefix='/playlist/export', items=c.d.libraries"/>
% endif

% if c.sub_dir_list:
<h3>Subdirectories:</h3>
${h.link_to("[as links]", c.node.custom_relative_path(prefix="/dir/as_links"))}
<%include file="directory_list.mako" />
% endif

% if c.d.other:
<h3>Other Files:</h3>
% for o in c.d.other:
${h.link_to("[edit]", o.custom_relative_path(prefix="/text/edit"))}
${h.link_to(o.name, o.custom_relative_path(prefix=""))}<br>
% endfor
% endif

% if c.admin:
<div class="row"><br></div>
% endif
