try:
    from setuptools import setup, find_packages
except ImportError:
    from ez_setup import use_setuptools
    use_setuptools()
    from setuptools import setup, find_packages

setup(
    name='pose',
    version='1.0',
    description='Pose is a general purpose content management system based on the Pylons framework',
    long_description="""\
Pose started as a python based image gallery utilizing the Pylons framework.

Since that time, Pose has evolved into a more general purpose content management system based on the Pylons framework.  It utilizes the OSBrowser module as an interface to the local filesystem being served by Pose.  OSBrowser is essentially the model in terms of MVC. In this way, Pose could be considered a web based filesytem browser.

Pose should allow you to quickly organize a collection of data into a structure and see how that structure will work.  Then, as custom functionality is needed, Pylons is right there to adapt the system to your needs.

Pose now includes tiny_mce, a few open source flash based audio players, and S5 rendering javascripts in the public directory.
""",
    author='Charles Brandt',
    author_email='code@contextiskey.com',
    url='http://www.contextiskey.com',
    install_requires=[
        "Pylons>=0.9.6",
        "Mako",
    ],
    setup_requires=["PasteScript==dev,>=1.6.3dev-r7326"],
    packages=find_packages(exclude=['ez_setup']),
    include_package_data=True,
    test_suite='nose.collector',
    package_data={'pose': ['i18n/*/LC_MESSAGES/*.mo']},
    #message_extractors = {'pose': [
    #        ('**.py', 'python', None),
    #        ('templates/**.mako', 'mako', None),
    #        ('public/**', 'ignore', None)]},
    zip_safe=False,
    paster_plugins=['PasteScript', 'Pylons'],
    entry_points="""
    [paste.app_factory]
    main = pose.config.middleware:make_app

    [paste.app_install]
    main = pylons.util:PylonsInstaller
    """,
)
