#!/bin/bash

# Set up all python related applications, including mercurial
# this is a quick way to get to a fully functional python system 
# version control

#if this is being sourced/ran by an external script, the following should
#already be defined externally.  
#if not, provide the path to your instance of Context:
#export USBPATH=/media/disk
#export USBPATH=/media/backups/context

export ARCHIVEPATH=$USBPATH/downloads/ubuntu/8.10

cd $ARCHIVEPATH/python
sudo dpkg -i *.deb

#install mercurial from source:
#this way causes problems with clone as of 1.1.2:
#cd $USBPATH/downloads/python/mercurial
#sudo make install
#so use easy_install instead:
cd $USBPATH/downloads/python
sudo easy_install -f . mercurial

#install pylons environment from eggs here.
cd $USBPATH/downloads/python/pylons-eggs
sudo easy_install -f . Pylons
sudo easy_install -f . wsgiref

#could install moments, osbrowser, medialist here:
#cd $USBPATH/code/python/moments/
#sudo python setup.py install
#cd $USBPATH/code/python/osbrowser
#sudo python setup.py install
#cd $USBPATH/code/python/medialist
#sudo python setup.py install

#installing a level up so that local context 
#can be linked and used as source for further development

#as in the case for .emacs files, 
#if you plan to modify code/python modules, you should wait to install them from a local disk
#otherwise you will have to shutdown the system to remove the USB
#if no modifications are expected, you could try installing here:
#cd $USBPATH/code/python/moments
#sudo python setup.py install

#moving away from the debian package version of mercurial... not updated as frequently
#cd $ARCHIVEPATH/common
#cd ../mercurial
#sudo dpkg -i *.deb



