#!/bin/bash
#SET UP AN UBUNTU LIVE SYSTEM:
#--------------------------------------
#add a shortcut to panel for the terminal
#open the terminal
#if you want to follow along, copy and paste directly in the terminal.

#what's your name?
export NAME=charles
echo "Hi $NAME"
echo "We're on our way now... ready... set..."
echo "Deep Breath... Inhale.... Exhale.... :)"
echo ""
#something manual to do in the mean time:
echo "system beep disabled?"
echo "desktop background set?"
echo ""

sudo ln -sf /usr/share/zoneinfo/America/New_York /etc/localtime

#be sure to mount any drives via system before accessing them here:
#export USBPATH=/media/disk
export USBPATH=/media/backups/context

cp $USBPATH/.bashrc ~/
#if following along manually,
#close terminal; re-open terminal to get updated bashrc
#in that case, you'll also need to re-export following environment variable:
#export USBPATH=/media/disk

#run the python startup script (includes mercurial)
{ $USBPATH/system/startup-python.sh; }

#create a local Context instance on your system
export LOCALPATH=/c
#hg clone $USBPATH $LOCALPATH
#-OR-
#run live from usb:
sudo ln -s $USBPATH $LOCALPATH

#keeping these here so they can be further developed locally 
cd $LOCALPATH/code/python/moments/
sudo python setup.py develop
cd $LOCALPATH/code/python/osbrowser
sudo python setup.py develop
cd $LOCALPATH/code/python/medialist
sudo python setup.py develop
cd $LOCALPATH/code/python/quotes
sudo python setup.py develop

#install pose
cd $LOCALPATH/code/python/pose
sudo python setup.py develop
#could start a local pose instance, then firefox, but this is system specific

ln -s $LOCALPATH/.exrc ~/.exrc

#run the general startup script
{ $USBPATH/system/startup-common.sh; }

sudo ln -s $LOCALPATH /$NAME 
ln -s $LOCALPATH ~/$NAME
ln -s $LOCALPATH ~/Desktop/$NAME
ln -s $LOCALPATH/instances.txt ~/Desktop/instances.txt

#run the emacs startup script
{ $USBPATH/system/startup-emacs.sh; }

ln -s $LOCALPATH/code/lisp/.emacs ~/.emacs
ln -s $LOCALPATH/code/lisp/.emacs.d ~/.emacs.d

#swap space is very handy. 
#if no local drives have swap space, you can create it manually:
#dd if=/dev/zero of=/media/data/swapfile.swp bs=1024 count=4096k
#cd /media/music
# one time only:
# mkswap swapfile.swp
#sudo swapon swapfile.swp

#add a launcher for your text editor to the panel
#open up your text editor! :)

#could start it here automatically, 
#emacs-snapshot-gtk &
#but manual ensures launcher is added to panel

#launch workspace preferences.
